<?php
/*ARTURO: Codigo para la Creacion de un custom type para ABM de paypals EN HIJO*/
/* 1 Creación del usuario supervisor*/
/*3.- Agregar un listener para paypal checkout*/
/*7.- Crear una page de redireccion (En tema hijo pais)*/


/**
 * 1.- Creación del usuario supervision por una sola vez
 */
function usuariopaypal2(){
	$blog_id = get_current_blog_id();
	$user_id = username_exists('supervision');

	if ( $user_id && ! is_user_member_of_blog( $user_id, $blog_id ) ) {
		//Exist's but is not user of the current blog id
		$result = add_user_to_blog( $blog_id, $user_id, 'shop_supervisor' );
	}

	$user_id = username_exists('despacho');

	if ( $user_id && ! is_user_member_of_blog( $user_id, $blog_id ) ) {
		//Exist's but is not user of the current blog id
		$result = add_user_to_blog( $blog_id, $user_id, 'shop_supervisor' );
	}

	$user = wp_get_current_user();
	$role = $user->roles;

}// fin funcion usuariopaypal2

add_action( 'admin_init', 'usuariopaypal2' );

/*3.- Agregar un listener para paypal checkout*/

function mi_script1() 
{
	$opt = get_option( '_invoices_options' );
	//$ruta = get_option( 'home' )."/";
	$subd=$opt{'subdirectorio'};
	$ruta=$_SERVER['HTTP_HOST'].$subd.get_blog_details()->path;
	echo '
	<script type="text/javascript">
		//*woocommerce_ppec_paypal_api_username* es el nombre y id del input que al hacer clic abrirá una ventana emergente vinculada desde donde se seleccionará el paypal.
		var el = document.getElementById("woocommerce_ppec_paypal_api_username");
		el.addEventListener("click", (event) => {
			//listapaypals es el permalink de una pagina que se debe crear y añadir el shortcode [paypals]
			//La pagina debe ser configurada con un template de ancho completo, si no existiere, crear uno en wp-content/themes/nombredeltema/page-templates/nombretemplate.php
			window.open("https://'.$ruta.'listapaypals", "Seleccionar paypals", "toolbar=0,scrollbars=0,location=0,statusbar=0,menubar=0,resizable=1,width=700,height=400,left = 890,top = 500");
			}
		);
	</script>';
}

add_action( 'admin_footer', 'mi_script1' );

/*4.- Crear un shortcode 'paypals'*/

function funcion_paypals() {
	if(current_user_can('ver_paypals')){
		global $wpdb;
		$sites = get_sites();
		$blogorig_id = get_current_blog_id();
		foreach ( $sites as $site ) {
			switch_to_blog( $site->blog_id );
			$opt = get_option( '_invoices_options' );
			if($opt['padrehijo']=="P"){

				$totalq="SELECT COUNT(ID) FROM {$wpdb->prefix}posts WHERE post_status='publish' AND post_type='paypals'";
				$total=$wpdb->get_var($totalq);

				$args = array(
				'posts_per_page'   => $total,
				'offset'           => 0,
				'category'         => '',
				'orderby'          => 'post_title',
				'order'            => 'ASC',
				'post_type'        => 'paypals',
				'post_status'      => 'publish',
				'suppress_filters' => true ); 
				$paypls = get_posts($args);
				$tabla="<h3 style='text-align:center;'>SELECCIONE UN PAYPAL.</h3>";
				$tabla.="<table class='wp-list-table striped' align='center'>";
				//$tabla.="<table class='wp-list-table widefat fixed striped table-view-list posts' align='center'>";
				//wp-list-table widefat fixed striped table-view-list posts
				$tabla.="<tr><td  align='right' width='10%'>NR.</td><td align='center' width='80%'>NOMBRE PAYPAL</td></tr>";
				$scripts="";
				$i=1;
				foreach ($paypls as $paypl){
					$id =$paypl->ID;

					$sites=get_post_meta($id,'_forsites');
					//echo $blogorig_id."_<br>";
					//print_r($sites);
					//echo "<br> ";
					if ($sites<>false){
						if(in_array($blogorig_id,$sites[0])){


							$tabla.="<tr><td align='right'><input style='width:30px;' readonly value='".$i++."'></td>";
							$tabla.="<td align='center'><input id='in_".$id."' name='in_".$id."' readonly value='".$paypl->post_title."'></td>";

							$liveAPIUsername=get_post_meta($id,'_liveAPIUsername');
							$liveAPIPassword=get_post_meta($id,'_liveAPIPassword');
							$liveAPISignature=get_post_meta($id,'_liveAPISignature');

							$APIUsername=$liveAPIUsername[0];
							$APIPassword=$liveAPIPassword[0];
							$APISignature=$liveAPISignature[0];
							//$tabla.="<td>".$APIUsername."</td>";$tabla.="<td>".$APIPassword."</td>";$tabla.="<td>".$APISignature."</td>";
							$tabla.="</tr>";
							$scripts.="var el = document.getElementById('in_".$id."');
								el.addEventListener('click', (event) => {
								window.opener.document.getElementById('woocommerce_ppec_paypal_api_username').value='".$APIUsername."';//TextBox1 is in parent page
								window.opener.document.getElementById('woocommerce_ppec_paypal_api_password').value='".$APIPassword."';//TextBox1 is in parent page
								window.opener.document.getElementById('woocommerce_ppec_paypal_api_signature').value='".$APISignature."';//TextBox1 is in parent page
								window.close();
								},true
								);";

						}//if in array blog id END
							
					}//if isset sites END
				}//foreach pappls as paypl END
				$tabla.="</table>";
				$url="https://".$_SERVER['SERVER_NAME']."/wp-admin/edit.php?post_type=paypals";
				//$tabla.="<br><p style='text-align:right'><a href='".$url."'>AÑADIR/MODIFICAR/BORRAR PAYPALS</a></p>";
				$tabla.= "<script type='text/javascript'>";
				$tabla.=$scripts;
				$tabla.= "</script>";
				
			}//fin de if opt padrehijo
			restore_current_blog();
		}//fin de foreach
    }else{
		$tabla = '<meta http-equiv="refresh" content="2;URL=/shop">';
    }
	return $tabla;
}

/*function paypalpadre(){
	$sites = get_sites();
	$blogorig_id = get_current_blog_id();
	$hay=FALSE;
	foreach ( $sites as $site ) {
		switch_to_blog( $site->blog_id );
		$opt = get_option( '_invoices_options' );
		if($opt['padrehijo']=="P"){
			if($site->blog_id<>1){
				$retorno="wp_".$site->blog_id."_posts";
				$hay=TRUE;
			}
		}//if opt padrehijo END
	}//foreach sites END
	if(!$hay){
		$retorno=wp_posts;
	}//if hay END
	return $retorno;
}//function paypalpadre END	
*/
add_shortcode('paypals','funcion_paypals');

/*6.- Crear una page 'listapaypals' (Si no existe)*/
function lista_paypals_page(){
	$blogorig_id = get_current_blog_id();
	$args = array(
		'post_title'	=> 'listapaypals',
		'post_status'		=> 'publish'
	);
	$my_posts = get_posts( $args );
	if(empty($my_posts))
	{
		$parametros=array(
		'ID'=>'',
		'post_author'=>$user->ID,
		'post_content'=>'[paypals]',
		'post_title'=>'listapaypals',
		'post_name'=>'listapaypals',
		'post_status'=>'publish',
		'post_type'=>'page'
		);
		$post_id = wp_insert_post($parametros);
		add_post_meta($post_id, '_wp_page_template', 'paypals_template.php', true);
	}// Fin de empty
	
}

add_action( 'admin_init', 'lista_paypals_page' );


/*7.- Crear una page de redireccion (En tema hijo pais)*/

function add_the_theme_page(){
	add_menu_page('Paypals', 'Paypals', 'ver_paypals', 'theme-options', 'page_content', 'dashicons-admin-post',27);
}
add_action('admin_menu', 'add_the_theme_page');
function page_content(){
	$opt = get_option( '_invoices_options' );
	$subd=$opt{'subdirectorio'};

	echo '<br><br><h4>El siguiente enlace redirige a la administracion general de paypals del sitio principal de esta tienda.</h4>';
	echo '<div><h2><a href="https://'.$_SERVER['HTTP_HOST'].$subd.'/wp-admin/edit.php?post_type=paypals" target="_blank">Clic aqui para añadir o modificar paypals</a></h2></div>';
	echo '<h4>Tome en cuenta que la tabla de paypals se administra de forma centralizada en la tienda principal.</h4>';
	echo '<h4>La selección de cuenta paypal en las tiendas por pais se realiza de la forma acostumbrada, en woocommerce/Settings/Payments/Paypal Checkout de la tienda, del pais.</h4>';
}
/*FIN DE: Codigo para la Creacion de un custom type para ABM de paypals*/